# RCSid:
#	$Id: dofile.pl,v 1.6 2001/08/30 07:48:36 sjg Exp $
#
#	@(#) Copyright (c) 1993 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

@RcPath = ($ENV{'HOME'},$Mydir,$ENV{'PATH'});

sub findfile {
  local($name,@path) = @_;
  local($file) = $name;
  
  if ($file =~ m,\.*/,) {
    return $file if (-e $file);
  } else {
    if (scalar(@path) < 1) {
      @path = ($ENV{'PATH'});
    }
    foreach $dir (split(/[:, ]/, join(',', @path))) {
      $file = "$dir/$name";
      return $file if (-e $file);
    }
  }
  undef;
}

sub Which {
  &findfile(@_);
}

sub do_file {
  local($rc,@path) = @_;

  @path = @RcPath if (scalar(@path) < 1);
  if ($rc = &findfile($rc,@path)) {
    do $rc if (-s $rc);		# avoid perl4 bug
  }
}

1;
